function loadListener(){
  this.removeEventListener("load", loadListener, true);
  this.loadURIWithFlags(this.getAttribute("wmn_url"));            
  this.removeAttribute("wmn_url");
}
WebMailNotifier.prototype.openTab = function(url,name,reuse,mailDomain,sessionId,newWin) {
  if(reuse){
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
    var enm = wm.getEnumerator("navigator:browser");
    while(enm.hasMoreElements()){
      var win=enm.getNext();
      var tabbrowser = win.getBrowser();
      for (var i = 0;i< tabbrowser.mTabContainer.childNodes.length;i++){
        var tab = tabbrowser.mTabContainer.childNodes[i];
        if (tab.hasAttribute("wmntab")&&tab.getAttribute("wmntab")==name) {
          var browser=tabbrowser.getBrowserForTab(tab);
          if(this.canReuse(browser.currentURI,mailDomain)){
            if(!this.multiSession&&name=="gmail"){
              browser.setAttribute("wmn_url",url);
              browser.addEventListener("load", loadListener, true);            
              browser.loadURIWithFlags("about:blank");            
            }else browser.loadURIWithFlags(url);
            tabbrowser.selectedTab = tab;
            if(this.multiSession&&sessionId!=null)this.setSessionId(win,tab,sessionId);            
            tabbrowser.contentWindow.focus();            
            return;
          }else{
            tab.removeAttribute("wmntab");
            browser.removeProgressListener(this);                
          }
        }
      }
    }
  }
  //not found
  var win=this.getWindow(true);
  if(newWin){
    win.open("about:blank");
    var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                        .getService(Components.interfaces.nsIWindowMediator);
    win = wm.getMostRecentWindow("navigator:browser");
  }
  var tabbrowser=win.getBrowser();
  var tab = tabbrowser.selectedTab;
  if(tabbrowser.currentURI.spec!="about:blank"||
      tab.hasAttribute("wmntab")){
    tab=tabbrowser.addTab("about:blank");
  }
  if(name!=null)tab.setAttribute("wmntab",name);  
  var browser=tabbrowser.getBrowserForTab(tab);  
  if(this.multiSession&&sessionId!=null){
    this.setSessionId(win,tab,sessionId);
    //tab.setAttribute("wmnsid",sessionId);      
    //try{if(this.multiSession)browser.addProgressListener(this);}catch(e){}
  }
  browser.loadURIWithFlags(url);
  tabbrowser.selectedTab = tab;    
  win.focus();
}
WebMailNotifier.prototype.setSessionId = function(win,tab,sid){
  if(sid==null||sid.toString()=="")sid=-1;
  if(sid==-1){
    tab.removeAttribute("wmnsid"); 

    var tabbrowser=win.getBrowser();  
    var browser=tabbrowser.getBrowserForTab(tab);      
    var doc=browser.contentDocument;
    try{
      if(doc.com.tobwithu.wmn.cookieGetter){
        var src=
          "doc.__defineGetter__('cookie',getter);\
          doc.__defineSetter__('cookie',setter);";
        var sandbox = new Components.utils.Sandbox(doc.defaultView);
        sandbox.doc=doc.wrappedJSObject;
        sandbox.getter=doc.com.tobwithu.wmn.cookieGetter;
        sandbox.setter=doc.com.tobwithu.wmn.cookieSetter;
        Components.utils.evalInSandbox(src,sandbox);
        delete doc.com.tobwithu.wmn.cookieGetter;
        delete doc.com.tobwithu.wmn.cookieSetter;
      }
    }catch(e){
dout("***"+e);
    }
  }else{
    var tabbrowser=win.getBrowser();  
    var browser=tabbrowser.getBrowserForTab(tab);      
    tab.setAttribute("wmnsid",sid); 
    try{browser.addProgressListener(this);}catch(e){}
  }  
}
WebMailNotifier.prototype.openNewWindow = function() {
    var win=Components.classes["@mozilla.org/appshell/appShellService;1"]
                    .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
    win.open("about:blank");
}
WebMailNotifier.prototype.openWindow = function(url,name,reuse,mailDomain,sid) {
  this.openTab(url,name,reuse,mailDomain,sid,true);
}
WebMailNotifier.prototype.getWindow = function(notChrome) {
 /* var win=Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
              .getService(Components.interfaces.nsIWindowWatcher).activeWindow;
  if(win==null){*/
  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                      .getService(Components.interfaces.nsIWindowMediator);
  var win = wm.getMostRecentWindow("navigator:browser");
  if(win==null){
    win=Components.classes["@mozilla.org/appshell/appShellService;1"]
                    .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
    if(notChrome){
      win.open("about:blank");
      win = wm.getMostRecentWindow("navigator:browser");
    }
  }
  return win;
}
WebMailNotifier.prototype.openLink = function(url) {
  var  win=Components.classes["@mozilla.org/appshell/appShellService;1"]
                    .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;  
  win.open(url);  
}
